// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================


#include <fennec/filesystem/path.h>

namespace fennec
{

#ifdef FENNEC_COMPILER_MSVC

path path::current() {
	char cstr[MAX_PATH];
	if (GetCurrentDirectory(sizeof(str), str) == 0) {
		return string("");
	}
	return path(cstr);
}

#else

#include <unistd.h>
#include <linux/limits.h>

path path::get_current() {
	char cstr[PATH_MAX];
	if (getcwd(cstr, sizeof(cstr)) == nullptr) {
		return path("");
	}
	return path(cstring(cstr, strlen(cstr)));
}

path path::set_current(const path& path) {
	if (chdir(path._str.cstr())) {
		return fennec::path("");
	}
	return get_current();
}

#endif

}